Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/DefaultJDynObjectComponent.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/DefaultJDynObjectComponent.java	(revision 167)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/DefaultJDynObjectComponent.java	(revision 168)
@@ -77,788 +70,353 @@
 			.getLogger(DefaultJDynObjectComponent.class);
 
 	private final I18nManager i18nManager = ToolsLocator.getI18nManager();
-	// private final UsabilitySwingManager usManager = ToolsSwingLocator
-	// .getUsabilitySwingManager();
-	private final DynObjectSwingManager dsManager = ToolsSwingLocator
-			.getDynObjectSwingManager();
 
-	public static final int SHOW_ALL = 0;
-	public static final int SHOW_ONLY_THIS_PARAMS = 1;
-	public static final int HIDDE_THIS_PARAMS = 2;
-
-	// private String title;
-
 	private DynObject parameters;
-	private List<DynField> fields;
-	// private JButton botAcept;
-	// private JButton botCancel;
-	// private JButton botRestoreDefaults;
-	// private boolean showButtons;
-	// private JPanel panButtons;
-	private JPanel panParameters;
-	private Map<DynField, Component> componentField;
 
 	private Color mandatoryLabelColor = Color.red;
-	// private boolean modal;
-	private JScrollPane parametersScroll;
-
 	protected Map<String, Object> tempValue = new HashMap<String, Object>();
-	public boolean srsShowTransformPanel;
+	private HashMap<DynField, JLabel> labelList;
 
-	public DefaultJDynObjectComponent(DynObject parameters) {
-		this(parameters, SHOW_ALL, null);
-	}
+	private JTabbedPane tabPanel;
 
-	public DefaultJDynObjectComponent(DynObject parameters, int mode,
-			List<String> paramsNames) {
-		this(parameters, mode, paramsNames,
-		// true,
-				false);
-	}
-
-	public DefaultJDynObjectComponent(DynObject parameters, int mode,
-			List<String> paramsNames,
-			// boolean showButtons,
-			boolean srsShowTransformPanel) {
-
-		super(parameters);
+	public DefaultJDynObjectComponent(DynObject parameters, DynObjectModel model) throws ServiceException {
+		super(parameters,model);
+		//added to handle labels correctly   
+		this.labelList = new HashMap<DynField,JLabel>();
 		this.parameters = parameters;
-		this.fields = Arrays.asList(parameters.getDynClass().getDynFields());
-		// this.showButtons = showButtons;
-		this.srsShowTransformPanel = srsShowTransformPanel;
-		if (mode == SHOW_ONLY_THIS_PARAMS || mode == HIDDE_THIS_PARAMS) {
-			if (paramsNames == null) {
-				throw new IllegalArgumentException("must expecify a name list");
-			}
-			ArrayList<DynField> toShow = new ArrayList<DynField>();
-			List<DynField> fields = Arrays.asList(parameters.getDynClass()
-					.getDynFields());
-			Iterator<DynField> iter = fields.iterator();
-			DynField field;
-			while (iter.hasNext()) {
-				field = iter.next();
+		this.tabPanel = new JTabbedPane();
+		//Uncomment the following line to use scrolling tabs.
+		this.tabPanel.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
+		addParametersFromModel();
 
-				if (mode == SHOW_ONLY_THIS_PARAMS
-						&& paramsNames.contains(field.getName())) {
-					toShow.add(field);
-				} else if (mode == HIDDE_THIS_PARAMS
-						&& !(paramsNames.contains(field.getName()))) {
-					toShow.add(field);
-				}
-			}
-			this.fields = toShow;
-		} else if (mode == SHOW_ALL) {
-
-		} else {
-			throw new IllegalArgumentException();
-		}
-		this.initialize();
-
 	}
-
-	private void initialize() {
-		this.setLayout(new BorderLayout(6, 6));
-		this.add(this.getParametersScroll(), BorderLayout.CENTER);
-
-		// if (this.showButtons) {
-		// this.add(this.getButtonsPanel(), BorderLayout.SOUTH);
-		// }
-		this.fromParamsToUI();
-	}
-
-	// private JPanel getButtonsPanel() {
-	// if (this.panButtons == null) {
-	// this.panButtons = new JPanel();
-	// this.panButtons.setLayout(new GridBagLayout());
-	// GridBagConstraints constr = new GridBagConstraints();
-	// constr.anchor = GridBagConstraints.LAST_LINE_END;
-	// constr.fill = GridBagConstraints.HORIZONTAL;
-	// constr.weightx = 1;
-	// constr.weighty = 0;
-	// this.panButtons.add(new JLabel(), constr);
-	//
-	// constr = this.getDefaultParametersConstraints();
-	// constr.fill = GridBagConstraints.NONE;
-	// constr.weightx = 0;
-	// constr.weighty = 0;
-	//
-	// this.panButtons.add(this.getAcceptButton(), constr);
-	// this.panButtons.add(this.getCancelButton(), constr);
-	// this.panButtons.add(this.getRestoreDefaults(), constr);
-	// }
-	// return this.panButtons;
-	// }
-
-	// private JButton getRestoreDefaults() {
-	// if (this.botRestoreDefaults == null) {
-	// this.botRestoreDefaults = usManager.createJButton(i18nManager
-	// .getTranslation("restoreDefaults"));
-	// this.botRestoreDefaults.addActionListener(this);
-	// }
-	// return this.botRestoreDefaults;
-	// }
-	//
-	// private JButton getCancelButton() {
-	// if (this.botCancel == null) {
-	// this.botCancel = usManager.createJButton(i18nManager
-	// .getTranslation("cancel"));
-	// this.botCancel.addActionListener(this);
-	// }
-	// return this.botCancel;
-	// }
-	//
-	// private JButton getAcceptButton() {
-	// if (this.botAcept == null) {
-	// this.botAcept = usManager.createJButton(i18nManager
-	// .getTranslation("accept"));
-	// this.botAcept.addActionListener(this);
-	// }
-	// return this.botAcept;
-	// }
-
-	private GridBagConstraints getDefaultParametersConstraints() {
+	
+	private void addGridBagComponent(JPanel panel, DynField field, int row) throws ServiceException {
+	    
+	    	JDynFieldComponent input =  getJDynFieldComponent(field, this);
+		
+		StatusLabel label = this.createFieldLabel(input);
+		input.addValueChangedListener(label);
+		
+		Component component = (Component) input.getComponent();
+		component.setName(field.getName());	
+		addComponentToList(component,input);
+			
+		//Arranging label and component into panel
+		
 		GridBagConstraints constr = new GridBagConstraints();
 		constr.insets = new Insets(2, 2, 2, 2);
+		constr.weighty = row;
 		constr.ipadx = 2;
 		constr.ipady = 2;
-		constr.anchor = GridBagConstraints.PAGE_START;
-		return constr;
-
-	}
-
-	private Component getParametersScroll() {
-		if (parametersScroll == null) {
-			parametersScroll = new JScrollPane();
-			parametersScroll.setViewportView(getParametersPanel());
-			parametersScroll.setBorder(null);
-			parametersScroll
-					.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
-			parametersScroll
-					.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
-		}
-		return parametersScroll;
-	}
-
-	private JPanel getParametersPanel() {
-		if (this.panParameters == null) {
-			this.panParameters = new JPanel();
-			this.panParameters.setLayout(new GridBagLayout());
-			// this.panParameters.setBorder(BorderFactory
-			// .createTitledBorder(this
-			// .getLocalizedText("values")));
-
-			Iterator<DynField> iter = this.fields.iterator();
-			DynField field;
-			while (iter.hasNext()) {
-				field = iter.next();
-				switch (field.getTheTypeOfAvailableValues()) {
-				case DynField.ANY:
-					this.addFieldSingle(this.panParameters, field);
-					break;
-				case DynField.CHOICE:
-					this.addFieldChoice(this.panParameters, field);
-					break;
-				case DynField.RANGE:
-					this.addFieldRange(this.panParameters, field);
-					break;
-
-				default:
-					// FIXME lanzar un warning???
-					this.addFieldSingle(this.panParameters, field);
-					break;
-				}
-
-			}
-			GridBagConstraints constr = new GridBagConstraints();
-			constr.fill = GridBagConstraints.BOTH;
-			constr.weightx = 1;
-			constr.weighty = 1;
-			constr.gridheight = GridBagConstraints.REMAINDER;
-			constr.gridwidth = GridBagConstraints.REMAINDER;
-			this.panParameters.add(new JLabel(), constr);
-		}
-		return this.panParameters;
-	}
-
-	private JLabel createFieldLabel(DynField field) {
-		JLabel label = new JLabel();
-		label.setText(i18nManager.getTranslation(field.getDescription()));
-
-		if (field.isMandatory()) {
-			label.setForeground(this.mandatoryLabelColor);
-		}
-		return label;
-	}
-
-	private void addFieldRange(JPanel panel, DynField field) {
-		GridBagConstraints constr = this.getDefaultParametersConstraints();
 		constr.fill = GridBagConstraints.HORIZONTAL;
-		constr.weighty = 0;
-		constr.weightx = 0;
+		constr.anchor = GridBagConstraints.NORTHWEST;
 
-		JLabel label = this.createFieldLabel(field);
-		constr.gridwidth = GridBagConstraints.RELATIVE;
+		constr.gridx = 0;
+		constr.gridy = row;
 		panel.add(label, constr);
 
-		constr.gridwidth = GridBagConstraints.REMAINDER;
-		constr.weightx = 1;
 
-		Object max, min;
-		double dmax, dmin, step;
-		max = field.getMaxValue();
-		min = field.getMinValue();
-		boolean decimal;
+		constr.fill = GridBagConstraints.HORIZONTAL;
+		constr.gridx = 1;
+		constr.weightx = 0.7;
+		panel.add(component, constr);
+		
+		input.fireValueChangedEvent();
+	}
 
-		if (!(max instanceof Number)) {
-			max = null;
-		}
-		if (!(min instanceof Number)) {
-			min = null;
-		}
-		dmax = 0;
-		dmin = 0;
-		step = 1;
+	private void addParametersFromModel() throws ServiceException {
+	    DynField field;
+	    JPanel pane;
+	    String[] groups = this.getModel().getGroups();
 
-		switch (field.getType()) {
-		case DataTypes.INT:
-			decimal = false;
-			if (max == null) {
-				max = Integer.MAX_VALUE;
-			} else {
-				dmax = ((Integer) max).doubleValue();
-			}
-			if (min == null) {
-				dmin = Integer.MIN_VALUE;
-			} else {
-				dmin = ((Integer) min).doubleValue();
-			}
-			break;
+	    for (String group: groups){
+		List items = this.getModel().getGroupElements(group);
+		
+		pane = new JPanel(new GridBagLayout());
+		
+	    	for (int i=0;i<items.size();i++) {
+		    field = ((DynFieldComponentModel)items.get(i))
+		    		.getDynField();
+		    addGridBagComponent(pane,field,i);
 
-		case DataTypes.LONG:
-			decimal = false;
-			if (max == null) {
-				dmax = Long.MAX_VALUE;
-			} else {
-				dmax = ((Long) max).doubleValue();
-			}
-			if (min == null) {
-				dmin = Long.MIN_VALUE;
-			} else {
-				dmin = ((Long) min).doubleValue();
-			}
-			break;
-
-		case DataTypes.BYTE:
-			decimal = false;
-			if (max == null) {
-				dmax = Byte.MAX_VALUE;
-			} else {
-				dmax = ((Byte) max).doubleValue();
-			}
-			if (min == null) {
-				dmin = Byte.MIN_VALUE;
-			} else {
-				dmin = ((Byte) min).doubleValue();
-			}
-			break;
-
-		case DataTypes.FLOAT:
-			decimal = true;
-			if (max == null) {
-				dmax = Float.MAX_VALUE;
-			} else {
-				dmax = ((Float) max).doubleValue();
-			}
-			if (min == null) {
-				dmin = Float.MIN_VALUE;
-			} else {
-				dmin = ((Float) min).doubleValue();
-			}
-			break;
-
-		case DataTypes.DOUBLE:
-			decimal = true;
-			if (max == null) {
-				dmax = Double.MAX_VALUE;
-			} else {
-				dmax = ((Double) max).doubleValue();
-			}
-			if (min == null) {
-				dmin = Double.MIN_VALUE;
-			} else {
-				dmin = ((Double) min).doubleValue();
-			}
-			break;
-
-		default:
-			JTextField text = new JTextField();
-			text.setEnabled(false);
-			panel.add(text, constr);
-			this.getComponentField().put(field, text);
-			return;
 		}
-		if ((dmax - dmin) != 0) {
-			step = (dmax - dmin) / 20;
-		}
+		this.tabPanel.addTab(group,createScrollPane(pane));
+	    }
+	}
 
-		SpinnerModel spinnerModel;
-		if (decimal) {
-			spinnerModel = new SpinnerNumberModel(dmin, dmin, dmax, step);
-		} else {
-			spinnerModel = new SpinnerNumberModel((int) dmin, (int) dmin,
-					(int) dmax, (int) step);
-		}
-		JSpinner spinner = new JSpinner(spinnerModel);
-		spinner.setName(field.getName());
-		constr.gridwidth = GridBagConstraints.REMAINDER;
-		constr.weightx = 1;
-		panel.add(spinner, constr);
-		this.getComponentField().put(field, spinner);
+	/**
+	 * @param label
+	 * @param field
+	 */
+	private void checkValidation(JLabel label, JDynFieldComponent field) {
+	    if (label==null) return;
+	    if (!isValid(field)){
+		label.setForeground(this.mandatoryLabelColor);
+	    }else{
+		label.setForeground(Color.BLACK);
+	    }
 	}
+	
+	protected void closeWindow() {
+		LOG.debug("Result DynObject: {}", parameters);
 
-	private void addFieldChoice(JPanel panel, DynField field) {
-		GridBagConstraints constr = this.getDefaultParametersConstraints();
-		constr.fill = GridBagConstraints.HORIZONTAL;
-		constr.weighty = 0;
-		constr.weightx = 0;
-
-		JLabel label = this.createFieldLabel(field);
-		constr.gridwidth = GridBagConstraints.RELATIVE;
-		panel.add(label, constr);
-
-		JComboBox combo = new JComboBox(field.getAvailableValues());
-		combo.setName(field.getName());
-		constr.gridwidth = GridBagConstraints.REMAINDER;
-		constr.weightx = 1;
-		panel.add(combo, constr);
-		this.getComponentField().put(field, combo);
-
+		// if (PluginServices.getMainFrame() == null) {
+		// ((JFrame) (getParent().getParent().getParent().getParent()))
+		// .dispose();
+		// } else {
+		// PluginServices.getMDIManager().closeWindow(this);
+		// }
 	}
+	
+	private StatusLabel createFieldLabel(JDynFieldComponent component) {
+	    	DynField field = component.getDynField();
+		String text = i18nManager.getTranslation(field.getDescription());
 
-	private void addFieldSingle(JPanel panel, DynField field) {
-		GridBagConstraints constr = this.getDefaultParametersConstraints();
-		constr.fill = GridBagConstraints.HORIZONTAL;
-		constr.weighty = 0;
-		constr.weightx = 0;
-
-		JLabel label = this.createFieldLabel(field);
-		constr.gridwidth = GridBagConstraints.RELATIVE;
-		panel.add(label, constr);
-
-		// JTextField text = new JTextField();
-		Component input = getComponentFor(field);
-		input.setName(field.getName());
-		constr.gridwidth = GridBagConstraints.REMAINDER;
-		constr.weightx = 1;
-		panel.add(input, constr);
-		this.getComponentField().put(field, input);
-
+		StatusLabel label = new StatusLabel(text, field.isMandatory());
+	
+		//adding label to a hashmap
+		this.labelList.put (field,label);
+		
+		return label;
 	}
 
-	private Component getComponentFor(DynField field) {
-		Component result = dsManager.createJDynFieldComponent(field,
-				getDynObject());
 
-		return (result == null) ? new JTextField() : result;
+	private Component createScrollPane(JPanel panel) throws ServiceException {
+	    JScrollPane scrollPane = new JScrollPane();
+	    scrollPane.setAlignmentX(JScrollPane.LEFT_ALIGNMENT);	 
+	    scrollPane.setAlignmentY(JScrollPane.TOP_ALIGNMENT);
+	   
+	    
+	    scrollPane.setViewportView(panel);
+	    scrollPane.setAutoscrolls(true);
+////	    scrollPane.setBorder(null);
+//	    scrollPane
+//		.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
+//	    scrollPane
+//		.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
+	    return scrollPane;
 	}
 
-	// class MyProjectionSelector extends JPanel {
-	// /**
-	// *
-	// */
-	// private static final long serialVersionUID = -6331922386501903468L;
+/* (non-Javadoc)
+ * @see org.gvsig.tools.swing.api.dynobject.JComponent#getComponent()
+ */
+public Object getComponent() {
+    return this.tabPanel;
+//	    return this.panel;
+}
+
+	/**
+	 * 	OTRAS PRUEBAS DELAYOUT
+	 */
+		
+	//	private GridBagConstraints getDefaultParametersConstraints() {
+	//	GridBagConstraints constr = new GridBagConstraints();
+	//	constr.insets = new Insets(2, 2, 2, 2);
+	//	constr.ipadx = 2;
+	//	constr.ipady = 2;
+	//	return constr;
+	//}
+	
+	//	private JPanel createNorthWestPane(JPanel pane){
+	//	    //Make a panel
+	//	    JPanel northWestPanel = new JPanel(new GridLayout(1,1));
+	//	    GridBagConstraints c = new GridBagConstraints();
+	//	    c.gridx = 0;
+	//	    c.gridy = 0;
+	//	    c.anchor = GridBagConstraints.NORTHWEST;
+	//	    c.insets = new Insets(0,0,0,0);
+	//	    northWestPanel.add(pane, c);
 	//
-	// private CRSSelectPanel crsSelector = null;
-	// private IProjection srs = null;
+	//	    northWestPanel.add(pane);
+	//	    return northWestPanel;
+	//	}
+		
+	//	/**
+	//	 * @throws ServiceException 
+	//	 * 
+	//	 */
+	//	private void addGridBagParametersFromModel() throws ServiceException {
 	//
-	// MyProjectionSelector(){
-	// super();
-	// init();
-	// }
+	//	    DynField field;
+	//	    JPanel pane;
+	//	    String[] groups = this.getModel().getGroups();
 	//
-	// private void init() {
-	// this.setValue(null);
-	// }
+	//	    for (String group: groups){
+	//		List items = this.getModel().getGroupElements(group);
+	//		
+	//		pane = new JPanel(new GridBagLayout());
+	//	    	pane.setBorder(BorderFactory.createTitledBorder("Prueba"));
+	//		
+	//	    	for (int i=0;i<items.size();i++) {
+	//		    field = ((DynFieldComponentModel)items.get(i))
+	//		    		.getDynField();
+	//		    addGridBagFieldSingle(pane,field,i);
+	//		}
+	////		this.tabPanel.addTab(group,createScrollPane(pane));
+	//		this.tabPanel.addTab(group,pane);
+	//	    }
+	//	    
+	//	    this.tabPanel.setSelectedIndex(0);
+	//	}
+		
+	//	private void addFieldSingle(JPanel panel, DynField field, int row) throws ServiceException {
+	//	    
+	//	    	JDynFieldComponent input =  getJDynFieldComponent(field, this);
+	//		
+	//		StatusLabel label = this.createFieldLabel(input);
+	//		input.addValueChangedListener(label);
+	//		
+	//		// JTextField text = new JTextField();
+	//		//Component input = getComponentFor(field);
+	//		Component component = (Component) input.getComponent();
+	//		component.setName(field.getName());	
+	//		addComponentToList(component,input);
+	//		
+	//		
+	//		//Arranging label and component into panel
+	//		
+	//		GridBagConstraints constr = this.getDefaultParametersConstraints();
+	//		
+	//		constr.fill = GridBagConstraints.HORIZONTAL;
+	//			    
+	//		constr.gridx = 0;
+	////		constr.gridy = row;
+	//		constr.gridheight = GridBagConstraints.RELATIVE;
+	//		constr.anchor = GridBagConstraints.PAGE_START;
+	//		constr.weighty = 0;
+	////		constr.w =  1;
+	////		constr.weightx = 0;
+	////		constr.gridheight = GridBagConstraints.RELATIVE;
+	//		panel.add(label, BorderLayout.WEST);
 	//
-	// private void setCurrentProj(IProjection proj) {
-	// if (proj == null){
-	// srs = null;
-	// } else {
-	// srs = proj;
-	// }
-	// }
 	//
-	// public void setValue(IProjection proj) {
-	// if (crsSelector != null) {
-	// this.remove(crsSelector);
-	// }
+	//		
+	//		panel.add(component, BorderLayout.CENTER);
+	//		
+	//		input.fireValueChangedEvent();
+	//	}
+	
+	//	private void initialize() throws ServiceException {
+	//		this.panel = new JPanel(new BorderLayout(6,6));
+	//		this.panel.setPreferredSize(new Dimension(800, 560));
+	//		
+	////		this.panel.add(this.getParametersScroll(), BorderLayout.PAGE_START);
 	//
-	// crsSelector = CRSSelectPanel.getPanel(proj);
-	// crsSelector
-	// .setTransPanelActive(DynObjectEditor.this.srsShowTransformPanel);
-	// crsSelector.addActionListener(new ActionListener() {
-	// public void actionPerformed(ActionEvent e) {
-	// setCurrentProj(crsSelector.getCurProj());
-	// }
-	// });
+	//		this.panel.add(this.getParametersPanel(isMainPanel), BorderLayout.PAGE_START);
+	////		this.panel =  this.getParametersScroll();
 	//
-	// this.add(crsSelector);
-	// this.doLayout();
-	// }
-	//
-	// public IProjection getValue() {
-	// return srs;
-	// }
-	//
-	//
-	//
-	// }
-
-	private void fromParamsToUISingle(DynField field, Component component) {
-
-		// Object value = parameters.getDynValue(field.getName());
-		// JTextField text;
-		// switch (field.getType()) {
-		// case DataTypes.STRING:
-		// text = (JTextField) component;
-		// if (value == null) {
-		// text.setText("");
-		// return;
-		// }
+	//		//		this.panel.add(this.panParameters);
+	//		// if (this.showButtons) {
+	//		// this.add(this.getButtonsPanel(), BorderLayout.SOUTH);
+	//		// }
+	////		this.fromParamsToUI();
+	//	}
+	
+		// private JPanel getButtonsPanel() {
+		// if (this.panButtons == null) {
+		// this.panButtons = new JPanel();
+		// this.panButtons.setLayout(new GridBagLayout());
+		// GridBagConstraints constr = new GridBagConstraints();
+		// constr.anchor = GridBagConstraints.LAST_LINE_END;
+		// constr.fill = GridBagConstraints.HORIZONTAL;
+		// constr.weightx = 1;
+		// constr.weighty = 0;
+		// this.panButtons.add(new JLabel(), constr);
 		//
-		// text.setText((String) value);
-		// break;
+		// const3r = this.getDefaultParametersConstraints();
+		// constr33.fill = GridBagConstraints.NONE;
+		// constr.weightx = 0;
+		// constr.weighty = 0;
 		//
-		// // case DataTypes.SRS:
-		// // ((MyProjectionSelector) component).setValue((IProjection) value);
-		// // break;
-		//
-		// default:
-		// text = (JTextField) component;
-		// if (value == null) {
-		// text.setText("");
-		// return;
+		// this.panButtons.add(this.getAcceptButton(), constr);
+		// this.panButtons.add(this.getCancelButton(), constr);
+		// this.panButtons.add(this.getRestoreDefaults(), constr);
 		// }
+		// return this.panButtons;
+		// }
+	
+		// private JButton getRestoreDefaults() {
+		// if (this.botRestoreDefaults == null) {
+		// this.botRestoreDefaults = usManager.createJButton(i18nManager
+		// .getTranslation("restoreDefaults"));
+		// this.botRestoreDefaults.addActionListener(this);
+		// }
+		// return this.botRestoreDefaults;
+		// }
 		//
-		// text.setText(value.toString());
-		// break;
+		// private JButton getCancelButton() {
+		// if (this.botCancel == null) {
+		// this.botCancel = usManager.createJButton(i18nManager
+		// .getTranslation("cancel"));
+		// this.botCancel.addActionListener(this);
 		// }
-
-	}
-
-	private void fromParamsToUIRange(DynField field, Component component) {
-		JSpinner spinner = (JSpinner) component;
-
-		Object value = parameters.getDynValue(field.getName());
-		double dValue = 0;
-		if (value == null) {
-			value = field.getMinValue();
-		}
-		if (value instanceof Double) {
-			dValue = ((Double) value).doubleValue();
-		} else if (value instanceof String) {
-			dValue = Double.parseDouble((String) value);
-		} else {
-			// FIXME ????
-			dValue = 0;
-		}
-		spinner.setValue(dValue);
-
-	}
-
-	private void fromParamsToUIChoice(DynField field, Component component) {
-		JComboBox combo = (JComboBox) component;
-		Object value = parameters.getDynValue(field.getName());
-
-		DynObjectValueItem item = null;
-		for (int i = 0; i < field.getAvailableValues().length; i++) {
-			if (value == null) {
-				if (field.getAvailableValues()[i].getValue() == null) {
-					item = field.getAvailableValues()[i];
-					break;
-				}
-			} else {
-				if (field.getAvailableValues()[i].getValue().equals(value)) {
-					item = field.getAvailableValues()[i];
-					break;
-				}
-
-			}
-		}
-
-		combo.getModel().setSelectedItem(item);
-
-	}
-
-	private void fromDefaultsToUISingle(DynField field, Component component) {
-		JTextField text = (JTextField) component;
-
-		if (field.getDefaultValue() == null) {
-			text.setText("");
-		} else if (field.getType() == DataTypes.STRING) {
-			text.setText((String) field.getDefaultValue());
-		} else {
-			text.setText(field.getDefaultValue().toString());
-		}
-
-	}
-
-	private void fromDefaultsToUIChoice(DynField field, Component component) {
-		JComboBox combo = (JComboBox) component;
-		Object value = field.getDefaultValue();
-
-		DynObjectValueItem item = null;
-		for (int i = 0; i < field.getAvailableValues().length; i++) {
-			if (value == null) {
-				if (field.getAvailableValues()[i].getValue() == null) {
-					item = field.getAvailableValues()[i];
-					break;
-				}
-			} else {
-				if (field.getAvailableValues()[i].getValue().equals(value)) {
-					item = field.getAvailableValues()[i];
-					break;
-				}
-
-			}
-		}
-
-		combo.getModel().setSelectedItem(item);
-	}
-
-	private void fromDefaultsToUIRange(DynField field, Component component) {
-		JSpinner spinner = (JSpinner) component;
-		Object value = field.getDefaultValue();
-		double dValue = 0;
-		if (value == null) {
-			value = field.getMinValue();
-		}
-
-		if (value instanceof Double) {
-			dValue = ((Double) value).doubleValue();
-		} else if (value instanceof String) {
-			dValue = Double.parseDouble((String) value);
-		} else {
-			// FIXME ????
-			dValue = 0;
-		}
-
-		spinner.setValue(dValue);
-	}
-
-	public void fromParamsToUI() {
-		Iterator<Entry<DynField, Component>> iter = this.getComponentField()
-				.entrySet().iterator();
-		Entry<DynField, Component> entry;
-		while (iter.hasNext()) {
-			entry = iter.next();
-
-			switch (entry.getKey().getTheTypeOfAvailableValues()) {
-			case DynField.ANY:
-				this.fromParamsToUISingle(entry.getKey(), entry.getValue());
-				break;
-			case DynField.CHOICE:
-				this.fromParamsToUIChoice(entry.getKey(), entry.getValue());
-				break;
-			case DynField.RANGE:
-				this.fromParamsToUIRange(entry.getKey(), entry.getValue());
-				break;
-
-			default:
-				// FIXME warning??
-				this.fromParamsToUISingle(entry.getKey(), entry.getValue());
-				break;
-			}
-
-		}
-	}
-
-	public void fromDefaultsToUI() {
-		Iterator<Entry<DynField, Component>> iter = this.getComponentField()
-				.entrySet().iterator();
-		Entry<DynField, Component> entry;
-		while (iter.hasNext()) {
-			entry = iter.next();
-
-			switch (entry.getKey().getTheTypeOfAvailableValues()) {
-			case DynField.ANY:
-				this.fromDefaultsToUISingle(entry.getKey(), entry.getValue());
-				break;
-			case DynField.CHOICE:
-				this.fromDefaultsToUIChoice(entry.getKey(), entry.getValue());
-				break;
-			case DynField.RANGE:
-				this.fromDefaultsToUIRange(entry.getKey(), entry.getValue());
-				break;
-
-			default:
-				// FIXME warning??
-				this.fromParamsToUISingle(entry.getKey(), entry.getValue());
-				break;
-			}
-
-		}
-	}
-
-	@Override
-	public void storeData() {
-		// TODO go through all JDynFieldComponents and call storeData() on them
-	}
-
-	private void fromUIToParams() {
-		Iterator<Entry<DynField, Component>> iter = this.getComponentField()
-				.entrySet().iterator();
-		Entry<DynField, Component> entry;
-		while (iter.hasNext()) {
-			entry = iter.next();
-
-			switch (entry.getKey().getTheTypeOfAvailableValues()) {
-			case DynField.ANY:
-				this.fromUIToParamsSingle(entry.getKey(), entry.getValue());
-				break;
-			case DynField.CHOICE:
-				this.fromUIToParamsChoice(entry.getKey(), entry.getValue());
-				break;
-			case DynField.RANGE:
-				this.fromUIToParamsRange(entry.getKey(), entry.getValue());
-				break;
-
-			default:
-				// FIXME warning??
-				this.fromUIToParamsSingle(entry.getKey(), entry.getValue());
-				break;
-			}
-
-		}
-
-	}
-
-	private void fromUIToParamsSingle(DynField field, Component component) {
-		JTextField text;
-
-		switch (field.getType()) {
-		case DataTypes.STRING:
-			text = (JTextField) component;
-			if (text.getText().length() == 0) {
-				String curValue = (String) parameters.getDynValue(field
-						.getName());
-				if (curValue == null || curValue.length() == 0) {
-					return;
-				}
-			}
-			parameters.setDynValue(field.getName(), text.getText());
-			break;
-
-		case DataTypes.INT:
-			text = (JTextField) component;
-			if (text.getText().length() == 0) {
-				Integer curValue = (Integer) parameters.getDynValue(field
-						.getName());
-				if (curValue == null) {
-					return;
-				}
-			}
-
-			// try{
-			parameters.setDynValue(field.getName(), new Integer(Integer
-					.parseInt(text.getText())));
-			// } catch (NumberFormatException e) {
-			// NotificationManager.addError(e);
-			// }
-			break;
-
-		case DataTypes.BOOLEAN:
-			text = (JTextField) component;
-
-			if (text.getText().length() == 0) {
-				Boolean curValue = (Boolean) parameters.getDynValue(field
-						.getName());
-				if (curValue == null) {
-					return;
-				}
-			}
-
-			parameters.setDynValue(field.getName(), new Boolean(Boolean
-					.parseBoolean(text.getText())));
-
-			break;
-
-		// case DataTypes.SRS:
-		// parameters.setDynValue(field.getName(),
-		// ((MyProjectionSelector) component).getValue());
+		// return this.botCancel;
+		// }
 		//
-		// break;
-
-		case DataTypes.OBJECT:
-			// TODO
-
-			break;
-		default:
-			// FIXME Warning !!!
-			text = (JTextField) component;
-			if (text.getText().length() == 0) {
-				Object curValue = parameters.getDynValue(field.getName());
-				if (curValue == null) {
-					return;
-				}
-			}
-
-			parameters.setDynValue(field.getName(), text.getText());
-			break;
-		}
-	}
-
-	private void fromUIToParamsChoice(DynField field, Component component) {
-		JComboBox combo = (JComboBox) component;
-		parameters.setDynValue(field.getName(), ((DynObjectValueItem) combo
-				.getSelectedItem()).getValue());
-	}
-
-	private void fromUIToParamsRange(DynField field, Component component) {
-		JSpinner spinner = (JSpinner) component;
-		parameters.setDynValue(field.getName(), spinner.getValue());
-
-	}
-
-	private Map<DynField, Component> getComponentField() {
-		if (this.componentField == null) {
-			this.componentField = new HashMap<DynField, Component>();
-		}
-		return componentField;
-
-	}
-
-	// public void actionPerformed(ActionEvent e) {
-	// Component source = (Component) e.getSource();
-	// if (source == this.botAcept) {
-	// this.fromUIToParams();
-	// this.closeWindow();
+		// private JButton getAcceptButton() {
+		// if (this.botAcept == null) {
+		// this.botAcept = usManager.createJButton(i18nManager
+		// .getTranslation("accept"));
+		// this.botAcept.addActionListener(this);
+		// }
+		// return this.botAcept;
+		// }
+	
+	//	private void addGridLayoutComponent(JPanel panel, DynField field, int row) throws ServiceException {
+	//	    
+	//	    	JDynFieldComponent input =  getJDynFieldComponent(field, this);
+	//		
+	//		StatusLabel label = this.createFieldLabel(input);
+	//		input.addValueChangedListener(label);
+	//		
+	//		// JTextField text = new JTextField();
+	//		//Component input = getComponentFor(field);
+	//		Component component = (Component) input.getComponent();
+	//		component.setName(field.getName());	
+	//		addComponentToList(component,input);
+	//		
+	//		
+	//		//Arranging label and component into panel
+	//		
+	//		GridBagConstraints constr = this.getDefaultParametersConstraints();
+	//		
+	////		constr.fill = GridBagConstraints.HORIZONTAL;
+	////			    
+	////		constr.gridx = 0;
+	//////		constr.gridy = row;
+	////		constr.gridheight = GridBagConstraints.RELATIVE;
+	////		if (row==0){
+	////		    constr.anchor = GridBagConstraints.NORTHWEST;
+	////		}else{
+	////		    constr.anchor = GridBagConstraints.PAGE_START;
+	////		}
+	////		constr.weighty = 0;
+	////		constr.w =  1;
+	////		constr.weightx = 0;
+	////		constr.gridheight = GridBagConstraints.RELATIVE;
+	//		panel.add(label);
 	//
-	// } else if (source == this.botCancel) {
-	// // TODO Close windows
-	// this.closeWindow();
-	// } else if (source == this.botRestoreDefaults) {
-	// this.fromDefaultsToUI();
 	//
-	// }
-	// if (!this.getComponentField().containsValue(e.getSource())) {
-	// return;
-	// }
-	// System.out.println("Action perform:" + source);
-	//
-	// }
+	////		constr.fill = GridBagConstraints.BOTH;
+	////		if (row==0){
+	////		    constr.anchor = GridBagConstraints.NORTHWEST;
+	////		}else{
+	////		    constr.anchor = GridBagConstraints.PAGE_START;
+	////		}
+	////		constr.gridx = 1;
+	////		constr.gridwidth = GridBagConstraints.NONE;
+	////		constr.weightx = 0.70;
+	//		panel.add(component);
+	//		
+	//		input.fireValueChangedEvent();
+	//	}
+	
+		
+		private JLabel getFieldLabel (DynField field){
+		    return this.labelList.get(field);
+		}
 
-	protected void closeWindow() {
-		LOG.debug("Result DynObject: {}", parameters);
-
-		// if (PluginServices.getMainFrame() == null) {
-		// ((JFrame) (getParent().getParent().getParent().getParent()))
-		// .dispose();
-		// } else {
-		// PluginServices.getMDIManager().closeWindow(this);
-		// }
-	}
-
 	// /* (non-Javadoc)
 	// * @see com.iver.andami.ui.mdiManager.IWindow#getWindowInfo()
 	// */
